diff -urN Original_4.4.4_r1/frameworks/native/include/gui/ISensorServer.h AndroidSource/frameworks/native/include/gui/ISensorServer.h
--- Original_4.4.4_r1/frameworks/native/include/gui/ISensorServer.h	2016-01-29 15:12:35.455488000 +0900
+++ AndroidSource/frameworks/native/include/gui/ISensorServer.h	2015-07-13 13:40:59.000000000 +0900
@@ -38,6 +38,8 @@
 
     virtual Vector<Sensor> getSensorList() = 0;
     virtual sp<ISensorEventConnection> createSensorEventConnection() = 0;
+    virtual void sendRemoteEvent(int32_t type, int32_t sensor, float* data, int8_t status, int64_t timestamp, int32_t sourcedevice) = 0;
+    virtual void setServerOn(bool flag) = 0;
 };
 
 // ----------------------------------------------------------------------------
diff -urN Original_4.4.4_r1/frameworks/native/include/gui/SensorManager.h AndroidSource/frameworks/native/include/gui/SensorManager.h
--- Original_4.4.4_r1/frameworks/native/include/gui/SensorManager.h	2016-01-29 15:12:35.455488000 +0900
+++ AndroidSource/frameworks/native/include/gui/SensorManager.h	2015-07-13 13:39:20.000000000 +0900
@@ -54,6 +54,8 @@
     ssize_t getSensorList(Sensor const* const** list) const;
     Sensor const* getDefaultSensor(int type);
     sp<SensorEventQueue> createEventQueue();
+    void sendRemoteEvent(int32_t type, int32_t sensor, float* data, int8_t status, int64_t timestamp, int32_t sourcedevice);
+    void setServerOn(bool flag);
 
 private:
     // DeathRecipient interface
diff -urN Original_4.4.4_r1/frameworks/native/include/input/Input.h AndroidSource/frameworks/native/include/input/Input.h
--- Original_4.4.4_r1/frameworks/native/include/input/Input.h	2016-01-29 15:12:35.459488000 +0900
+++ AndroidSource/frameworks/native/include/input/Input.h	2015-08-04 10:03:28.000000000 +0900
@@ -323,6 +323,12 @@
 
     virtual int32_t getType() const { return AINPUT_EVENT_TYPE_MOTION; }
 
+    // ADDED BY JH
+	//inline int32_t getSourceDevice() const { return mSourceDevice; }
+
+	//inline void setSourceDevice(int32_t sourceDevice) { mSourceDevice = sourceDevice; }
+	// ADDED BY JH
+
     inline int32_t getAction() const { return mAction; }
 
     inline int32_t getActionMasked() const { return mAction & AMOTION_EVENT_ACTION_MASK; }
@@ -497,9 +503,28 @@
 
     ssize_t findPointerIndex(int32_t pointerId) const;
 
+    /*void initialize(
+			int32_t deviceId,
+			int32_t source,
+			int32_t action,
+			int32_t flags,
+			int32_t edgeFlags,
+			int32_t metaState,
+			int32_t buttonState,
+			float xOffset,
+			float yOffset,
+			float xPrecision,
+			float yPrecision,
+			nsecs_t downTime,
+			nsecs_t eventTime,
+			size_t pointerCount,
+			const PointerProperties* pointerProperties,
+			const PointerCoords* pointerCoords);*/
+
     void initialize(
             int32_t deviceId,
             int32_t source,
+            //int32_t sourceDevice,
             int32_t action,
             int32_t flags,
             int32_t edgeFlags,
@@ -549,6 +574,8 @@
     }
 
 protected:
+    // ADDED BY JH
+    //int32_t mSourceDevice;
     int32_t mAction;
     int32_t mFlags;
     int32_t mEdgeFlags;
diff -urN Original_4.4.4_r1/frameworks/native/include/input/InputTransport.h AndroidSource/frameworks/native/include/input/InputTransport.h
--- Original_4.4.4_r1/frameworks/native/include/input/InputTransport.h	2016-01-29 15:12:35.459488000 +0900
+++ AndroidSource/frameworks/native/include/input/InputTransport.h	2015-08-04 12:04:20.000000000 +0900
@@ -76,6 +76,7 @@
             nsecs_t eventTime;
             int32_t deviceId;
             int32_t source;
+            int32_t sourceDevice;
             int32_t action;
             int32_t flags;
             int32_t metaState;
@@ -223,6 +224,7 @@
             uint32_t seq,
             int32_t deviceId,
             int32_t source,
+            //int32_t sourceDevice,
             int32_t action,
             int32_t flags,
             int32_t edgeFlags,
diff -urN Original_4.4.4_r1/frameworks/native/libs/gui/ISensorServer.cpp AndroidSource/frameworks/native/libs/gui/ISensorServer.cpp
--- Original_4.4.4_r1/frameworks/native/libs/gui/ISensorServer.cpp	2016-01-29 15:12:35.463488000 +0900
+++ AndroidSource/frameworks/native/libs/gui/ISensorServer.cpp	2015-07-13 13:41:10.000000000 +0900
@@ -47,7 +47,7 @@
 
     virtual Vector<Sensor> getSensorList()
     {
-        Parcel data, reply;
+    	Parcel data, reply;
         data.writeInterfaceToken(ISensorServer::getInterfaceDescriptor());
         remote()->transact(GET_SENSOR_LIST, data, &reply);
         Sensor s;
@@ -68,6 +68,16 @@
         remote()->transact(CREATE_SENSOR_EVENT_CONNECTION, data, &reply);
         return interface_cast<ISensorEventConnection>(reply.readStrongBinder());
     }
+
+    virtual void sendRemoteEvent(int32_t type, int32_t sensor, float* data, int8_t status, int64_t timestamp, int32_t sourcedevice)
+    {
+    	ALOGD("Hello I'm ISensorServer!!");
+    }
+
+    virtual void setServerOn(bool flag)
+	{
+		ALOGD("Hello I'm ISensorServer!!");
+	}
 };
 
 IMPLEMENT_META_INTERFACE(SensorServer, "android.gui.SensorServer");
diff -urN Original_4.4.4_r1/frameworks/native/libs/gui/SensorManager.cpp AndroidSource/frameworks/native/libs/gui/SensorManager.cpp
--- Original_4.4.4_r1/frameworks/native/libs/gui/SensorManager.cpp	2016-01-29 15:12:35.463488000 +0900
+++ AndroidSource/frameworks/native/libs/gui/SensorManager.cpp	2015-07-13 13:33:51.000000000 +0900
@@ -103,7 +103,7 @@
 
 ssize_t SensorManager::getSensorList(Sensor const* const** list) const
 {
-    Mutex::Autolock _l(mLock);
+	Mutex::Autolock _l(mLock);
     status_t err = assertStateLocked();
     if (err < 0) {
         return ssize_t(err);
@@ -129,7 +129,7 @@
 
 sp<SensorEventQueue> SensorManager::createEventQueue()
 {
-    sp<SensorEventQueue> queue;
+	sp<SensorEventQueue> queue;
 
     Mutex::Autolock _l(mLock);
     while (assertStateLocked() == NO_ERROR) {
@@ -146,5 +146,25 @@
     return queue;
 }
 
+void SensorManager::sendRemoteEvent(int32_t type, int32_t sensor, float* data, int8_t status, int64_t timestamp, int32_t sourcedevice)
+{
+	Mutex::Autolock _l(mLock);
+	while (assertStateLocked() == NO_ERROR)
+	{
+		mSensorServer->sendRemoteEvent(type, sensor, data, status, timestamp, sourcedevice);
+		break;
+	}
+}
+
+void SensorManager::setServerOn(bool flag)
+{
+	Mutex::Autolock _l(mLock);
+	while (assertStateLocked() == NO_ERROR)
+	{
+		mSensorServer->setServerOn(flag);
+		break;
+	}
+}
+
 // ----------------------------------------------------------------------------
 }; // namespace android
diff -urN Original_4.4.4_r1/frameworks/native/libs/input/Input.cpp AndroidSource/frameworks/native/libs/input/Input.cpp
--- Original_4.4.4_r1/frameworks/native/libs/input/Input.cpp	2016-01-29 15:12:35.463488000 +0900
+++ AndroidSource/frameworks/native/libs/input/Input.cpp	2015-08-04 10:01:44.000000000 +0900
@@ -280,7 +280,6 @@
 
 
 // --- MotionEvent ---
-
 void MotionEvent::initialize(
         int32_t deviceId,
         int32_t source,
@@ -316,8 +315,49 @@
     addSample(eventTime, pointerCoords);
 }
 
+/*void MotionEvent::initialize(
+        int32_t deviceId,
+        int32_t source,
+        int32_t sourceDevice,
+        int32_t action,
+        int32_t flags,
+        int32_t edgeFlags,
+        int32_t metaState,
+        int32_t buttonState,
+        float xOffset,
+        float yOffset,
+        float xPrecision,
+        float yPrecision,
+        nsecs_t downTime,
+        nsecs_t eventTime,
+        size_t pointerCount,
+        const PointerProperties* pointerProperties,
+        const PointerCoords* pointerCoords) {
+    InputEvent::initialize(deviceId, source);
+    mSourceDevice = sourceDevice;
+    ALOGD("init2: %d", mSourceDevice);
+    mAction = action;
+    mFlags = flags;
+    mEdgeFlags = edgeFlags;
+    mMetaState = metaState;
+    mButtonState = buttonState;
+    mXOffset = xOffset;
+    mYOffset = yOffset;
+    mXPrecision = xPrecision;
+    mYPrecision = yPrecision;
+    mDownTime = downTime;
+    mPointerProperties.clear();
+    mPointerProperties.appendArray(pointerProperties, pointerCount);
+    mSampleEventTimes.clear();
+    mSamplePointerCoords.clear();
+    addSample(eventTime, pointerCoords);
+}*/
+
 void MotionEvent::copyFrom(const MotionEvent* other, bool keepHistory) {
     InputEvent::initialize(other->mDeviceId, other->mSource);
+    // ADDED BY JH
+    //mSourceDevice = other->mSourceDevice;
+    //ALOGD("copyFrom: %d", mSourceDevice);
     mAction = other->mAction;
     mFlags = other->mFlags;
     mEdgeFlags = other->mEdgeFlags;
@@ -496,6 +536,9 @@
 
     mDeviceId = parcel->readInt32();
     mSource = parcel->readInt32();
+    // ADDED BY JH
+    //mSourceDevice = parcel->readInt32();
+    //ALOGD("mSourceDevice-read in cpp: %d", mSourceDevice);
     mAction = parcel->readInt32();
     mFlags = parcel->readInt32();
     mEdgeFlags = parcel->readInt32();
@@ -543,6 +586,9 @@
 
     parcel->writeInt32(mDeviceId);
     parcel->writeInt32(mSource);
+    // ADDED BY JH
+    //parcel->writeInt32(mSourceDevice);
+    //ALOGD("mSourceDevice-write in cpp: %d", mSourceDevice);
     parcel->writeInt32(mAction);
     parcel->writeInt32(mFlags);
     parcel->writeInt32(mEdgeFlags);
@@ -591,7 +637,6 @@
     return false;
 }
 
-
 // --- PooledInputEventFactory ---
 
 PooledInputEventFactory::PooledInputEventFactory(size_t maxPoolSize) :
diff -urN Original_4.4.4_r1/frameworks/native/libs/input/InputTransport.cpp AndroidSource/frameworks/native/libs/input/InputTransport.cpp
--- Original_4.4.4_r1/frameworks/native/libs/input/InputTransport.cpp	2016-01-29 15:12:35.463488000 +0900
+++ AndroidSource/frameworks/native/libs/input/InputTransport.cpp	2015-08-04 10:02:59.000000000 +0900
@@ -281,6 +281,7 @@
         uint32_t seq,
         int32_t deviceId,
         int32_t source,
+        //int32_t sourceDevice,
         int32_t action,
         int32_t flags,
         int32_t edgeFlags,
@@ -322,6 +323,7 @@
     msg.body.motion.seq = seq;
     msg.body.motion.deviceId = deviceId;
     msg.body.motion.source = source;
+    //msg.body.motion.sourceDevice = sourceDevice;
     msg.body.motion.action = action;
     msg.body.motion.flags = flags;
     msg.body.motion.edgeFlags = edgeFlags;
@@ -486,7 +488,8 @@
             MotionEvent* motionEvent = factory->createMotionEvent();
             if (! motionEvent) return NO_MEMORY;
 
-            updateTouchState(&mMsg);
+            //ALOGD("InputTransport-consume: %d",mMsg.body.motion.sourceDevice);
+
             initializeMotionEvent(motionEvent, &mMsg);
             *outSeq = mMsg.body.motion.seq;
             *outEvent = motionEvent;
@@ -902,9 +905,11 @@
         pointerCoords[i].copyFrom(msg->body.motion.pointers[i].coords);
     }
 
+    //ALOGD("inputTransport-initializeMotionEvent: %d", msg->body.motion.sourceDevice);
     event->initialize(
             msg->body.motion.deviceId,
             msg->body.motion.source,
+            //msg->body.motion.sourceDevice,
             msg->body.motion.action,
             msg->body.motion.flags,
             msg->body.motion.edgeFlags,
diff -urN Original_4.4.4_r1/frameworks/native/services/sensorservice/Android.mk AndroidSource/frameworks/native/services/sensorservice/Android.mk
--- Original_4.4.4_r1/frameworks/native/services/sensorservice/Android.mk	2016-01-29 15:12:35.519488000 +0900
+++ AndroidSource/frameworks/native/services/sensorservice/Android.mk	2015-11-18 13:51:48.000000000 +0900
@@ -12,7 +12,8 @@
     SensorDevice.cpp \
     SensorFusion.cpp \
     SensorInterface.cpp \
-    SensorService.cpp
+    SensorService.cpp \
+    RemoteSensor.cpp
 
 LOCAL_CFLAGS:= -DLOG_TAG=\"SensorService\"
 
diff -urN Original_4.4.4_r1/frameworks/native/services/sensorservice/Android.mk~ AndroidSource/frameworks/native/services/sensorservice/Android.mk~
--- Original_4.4.4_r1/frameworks/native/services/sensorservice/Android.mk~	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/native/services/sensorservice/Android.mk~	2015-01-09 01:03:55.000000000 +0900
@@ -0,0 +1,51 @@
+LOCAL_PATH:= $(call my-dir)
+include $(CLEAR_VARS)
+
+LOCAL_SRC_FILES:= \
+	BatteryService.cpp \
+	CorrectedGyroSensor.cpp \
+    Fusion.cpp \
+    GravitySensor.cpp \
+    LinearAccelerationSensor.cpp \
+    OrientationSensor.cpp \
+    RotationVectorSensor.cpp \
+    SensorDevice.cpp \
+    SensorFusion.cpp \
+    SensorInterface.cpp \
+    SensorService.cpp
+
+LOCAL_CFLAGS:= -DLOG_TAG=\"SensorService\"
+
+LOCAL_CFLAGS += -fvisibility=hidden
+
+LOCAL_SHARED_LIBRARIES := \
+	libcutils \
+	libhardware \
+	libhardware_legacy \
+	libutils \
+	liblog \
+	libbinder \
+	libui \
+	libgui
+
+LOCAL_MODULE:= libsensorservice
+
+include $(BUILD_SHARED_LIBRARY)
+
+#####################################################################
+# build executable
+include $(CLEAR_VARS)
+
+LOCAL_SRC_FILES:= \
+	main_sensorservice.cpp
+
+LOCAL_SHARED_LIBRARIES := \
+	libsensorservice \
+	libbinder \
+	libutils
+
+LOCAL_MODULE_TAGS := optional
+
+LOCAL_MODULE:= sensorservice
+
+include $(BUILD_EXECUTABLE)
diff -urN Original_4.4.4_r1/frameworks/native/services/sensorservice/RemoteSensor.cpp AndroidSource/frameworks/native/services/sensorservice/RemoteSensor.cpp
--- Original_4.4.4_r1/frameworks/native/services/sensorservice/RemoteSensor.cpp	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/native/services/sensorservice/RemoteSensor.cpp	2015-11-04 22:24:51.000000000 +0900
@@ -0,0 +1,65 @@
+/*
+ * Copyright (C) 2010 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#include <stdint.h>
+#include <math.h>
+#include <sys/types.h>
+
+#include <utils/Errors.h>
+
+#include <hardware/sensors.h>
+
+#include "RemoteSensor.h"
+
+namespace android {
+// ---------------------------------------------------------------------------
+
+RemoteSensor::RemoteSensor()
+    : mSensorDevice(SensorDevice::getInstance()),
+      mSensorFusion(SensorFusion::getInstance())
+{
+}
+
+bool RemoteSensor::process(sensors_event_t* outEvent,
+        const sensors_event_t& event)
+{
+ 	return true;
+}
+
+status_t RemoteSensor::activate(void* ident, bool enabled) {
+    return mSensorFusion.activate(ident, enabled);
+}
+
+status_t RemoteSensor::setDelay(void* ident, int handle, int64_t ns) {
+    return mSensorFusion.setDelay(ident, ns);
+}
+
+Sensor RemoteSensor::getSensor() const {
+    sensor_t hwSensor;
+    hwSensor.name       = "Remote Sensor";
+    hwSensor.vendor     = "AOSP";
+    hwSensor.version    = 3;
+    hwSensor.handle     = 21;
+    hwSensor.type       = 21;
+    hwSensor.maxRange   = 1;
+    hwSensor.resolution = 1.0f / (1<<24);
+    hwSensor.power      = mSensorFusion.getPowerUsage();
+    hwSensor.minDelay   = mSensorFusion.getMinDelay();
+    Sensor sensor(&hwSensor);
+    return sensor;
+}
+}; // namespace android
+
diff -urN Original_4.4.4_r1/frameworks/native/services/sensorservice/RemoteSensor.h AndroidSource/frameworks/native/services/sensorservice/RemoteSensor.h
--- Original_4.4.4_r1/frameworks/native/services/sensorservice/RemoteSensor.h	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/native/services/sensorservice/RemoteSensor.h	2015-11-04 21:17:17.000000000 +0900
@@ -0,0 +1,51 @@
+/*
+ * Copyright (C) 2010 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef ANDROID_REMOTE_SENSOR_SENSOR_H
+#define ANDROID_REMOTE_SENSOR_SENSOR_H
+
+#include <stdint.h>
+#include <sys/types.h>
+
+#include <gui/Sensor.h>
+
+#include "SensorDevice.h"
+#include "SensorInterface.h"
+
+#include "Fusion.h"
+#include "SensorFusion.h"
+
+// ---------------------------------------------------------------------------
+namespace android {
+// ---------------------------------------------------------------------------
+
+class RemoteSensor : public SensorInterface {
+    SensorDevice& mSensorDevice;
+    SensorFusion& mSensorFusion;
+
+public:
+    RemoteSensor();
+    virtual bool process(sensors_event_t* outEvent,
+            const sensors_event_t& event);
+    virtual status_t activate(void* ident, bool enabled);
+    virtual status_t setDelay(void* ident, int handle, int64_t ns);
+    virtual Sensor getSensor() const;
+    virtual bool isVirtual() const { return true; }
+};
+
+}; // namespace android
+
+#endif // ANDROID_ROTATION_VECTOR_SENSOR_H
diff -urN Original_4.4.4_r1/frameworks/native/services/sensorservice/SensorService.cpp AndroidSource/frameworks/native/services/sensorservice/SensorService.cpp
--- Original_4.4.4_r1/frameworks/native/services/sensorservice/SensorService.cpp	2016-01-29 15:12:35.523488000 +0900
+++ AndroidSource/frameworks/native/services/sensorservice/SensorService.cpp	2016-06-23 21:59:35.000000000 +0900
@@ -40,15 +40,23 @@
 #include <hardware/sensors.h>
 #include <hardware_legacy/power.h>
 
+//#include <android/log.h>
+
 #include "BatteryService.h"
 #include "CorrectedGyroSensor.h"
 #include "GravitySensor.h"
 #include "LinearAccelerationSensor.h"
 #include "OrientationSensor.h"
 #include "RotationVectorSensor.h"
+#include "RemoteSensor.h"
 #include "SensorFusion.h"
 #include "SensorService.h"
 
+/*
+ #define  LOG_TAG    "NativeSenserService"
+ #define  ALOG(...)  __android_log_print(ANDROID_LOG_INFO,LOG_TAG,__VA_ARGS__)
+ */
+
 namespace android {
 // ---------------------------------------------------------------------------
 
